comment 

        Hi there! I wrote this program 'cause I intended to code an
        ANIM5-player, but I didn't have a clue on how to do it... Eh?
        What's love got to do with it?

        Anyway, it displays 256-colors ILBM-files correctly, at least if
        they are 320 pixels wide and packed with the ByteRun1 encoding.
        Beware that if your pics are higher than 200 lines, then only
        the 200 uppermost lines will be displayed... As i mentioned, the
        pics may NOT be unpacked. I suppose I could have added support
        for that too, but I frankly haven't seen any unpacked ILBM's, so
        I guess there just aren't too many of them around... Also, the
        pictures may NOT have a mask!

        Hmm, not much more too say, use the code if you find it useful.
        It may not be too nicely written, but hey, it's free! :)

        The program implements some basic errorchecking, look at it
        yourself... Not much comments, eh? Sorry for that, I just don't
        enjoy commenting my code... ;) You've got a few lovely ones
        though...

        80x50 rules! Hehe... ;)

        

.model tiny
.386
.code
org 100h
_main:
        mov     dx,offset initmsg
        call    _puts

        xor     bx,bx
        mov     bl,ds:[0080h]
        mov     byte ptr [0081h+bx],0
        or      bl,bl
        je      _exit

        mov     ax,3d00h
        mov     dx,82h
        int     21h
        jc      _error
        xchg    bx,ax

        mov     cx,12
        mov     dx,offset buffer
        call    _readxbytes
        cmp     dword ptr buffer,'MROF'
        jne     _error

        cmp     dword ptr buffer[8],'MBLI'
        jne     _error

        mov     ebp,'DHMB'
        call    _search

        mov     cx,16
        mov     dx,offset buffer
        call    _readxbytes
        cmp     word ptr buffer[4],4001h        ; 320 wide?
        jne     _error

        cmp     dword ptr buffer[12],00010008h  ; 256c, ByteRun1 & no mask?
        jne     _error

        mov     ebp,'PAMC'
        call    _search

        mov     cx,768+4
        mov     dx,offset buffer-4
        call    _readxbytes
        mov     di,dx
pallop:
        shr     byte ptr [di],2
        inc     di
        loopw   pallop

        mov     ebp,'YDOB'
        call    _search

        mov     ax,0013h
        int     10h
        mov     dx,3c8h
        xor     al,al
        out     dx,al
        inc     dx
        mov     si,offset buffer
        mov     cx,768
        rep     outsb

        mov     dx,offset buffer-4
        mov     cx,64004
        call    _readxbytes

        mov     ax,0a000h
        mov     ds,ax
        mov     di,320
        xor     bp,bp
        mov     si,offset buffer-1
        xor     cx,cx
_subdi:
        sub     di,320
_unpnext:
        inc     si
        cmp     byte ptr cs:[si],-128   ; WHY is this necessary???
        je      _unpnext
        test    byte ptr cs:[si],128
        jz      _copydirectly
        movsx   bx,byte ptr cs:[si]
        neg     bx
        inc     bx
        inc     si
        mov     ah,cs:[si]
lop1:
        call    _putbyte
        dec     bx
        jnz     lop1
        jmp     _commonstuff1

_copydirectly:
        movzx   bx,byte ptr cs:[si]
        inc     bx
lop2:
        inc     si
        mov     ah,cs:[si]
        call    _putbyte
        dec     bx
        jnz     lop2
_commonstuff1:
        cmp     bp,320
        jb      _unpnext
        xor     bp,bp
        inc     cx
        cmp     cl,8
        jb      _subdi
        xor     cx,cx
        cmp     di,64000
        jb      _unpnext

_wait&settxt:
        xor     ax,ax
        int     16h
        mov     ax,1202h
        mov     bl,30h
        int     10h
        mov     ax,0003h
        int     10h
        mov     ax,1112h
        xor     bx,bx
        int     10h
                                ; Hoho, saving one byte... we will
                                ; eventually reach a "retn" further down
                                ; here... :)

;
_putbyte:
        shld    dx,ax,1
        and     dl,1
        shl     dl,cl
        or      [di],dl

        shld    dx,ax,2
        and     dl,1
        shl     dl,cl
        or      [di+1],dl

        shld    dx,ax,3
        and     dl,1
        shl     dl,cl
        or      [di+2],dl

        shld    dx,ax,4
        and     dl,1
        shl     dl,cl
        or      [di+3],dl

        shld    dx,ax,5
        and     dl,1
        shl     dl,cl
        or      [di+4],dl

        shld    dx,ax,6
        and     dl,1
        shl     dl,cl
        or      [di+5],dl

        shld    dx,ax,7
        and     dl,1
        shl     dl,cl
        or      [di+6],dl

        shld    dx,ax,8
        and     dl,1
        shl     dl,cl
        or      [di+7],dl

        add     di,8
        add     bp,8
        ret

;
; In:   EBP = String to search for, e.g 'YDOB' searches for 'BODY'
; Out:  CF = 1 => Didn't find it!
_search:
        mov     ax,4200h
        xor     cx,cx
        mov     dx,12
        int     21h
_again:
        mov     cx,4
        mov     dx,offset searchbuf
        call    _readxbytes
        cmp     searchbuf,ebp
        je      _ret
        call    _readxbytes
        mov     cx,word ptr searchbuf[2]
        rol     cx,8
        mov     dx,offset buffer+768
        call    _readxbytes
        jmp     _again

;
; Bytes to read to [DX] in CX
_readxbytes:
        mov     ah,3fh
        int     21h
        jc      _pushzero
        or      ax,ax
        jnz     _ret
_pushzero:
        db      68h,00h,00h             ; push faked ip...

;
_error:
        mov     dx,offset errormsg

;
_puts:
        mov     ah,9
        int     21h
_exit:
_ret:
        ret

;
initmsg   db    'Viewer by Omega / Moment 22',10,13
          db    'Use: SIL file.ext',10,13,10,'$'
errormsg  db    'ERROR!',10,'$'

searchbuf dd    ?
buffer    db    64000 dup(?)

;
end _main
